OpenTTD Source: NetworkStunConnecter Class Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Private Attributes
NetworkStunConnecter Class Reference

Connect to the STUN server. More...

Inheritance diagram for NetworkStunConnecter:

## Public Member Functions
| NetworkStunConnecter (ClientNetworkStunSocketHandler *stun_handler, std::string_view connection_string, std::string_view token, uint8_t family)
| Initiate the connecting.
void | OnFailure () override
| Callback for when the connection attempt failed.
void | OnConnect (SOCKET s) override
| Callback when the connection succeeded.
Public Member Functions inherited from TCPConnecter
| TCPConnecter (std::string_view connection_string, uint16_t default_port, const NetworkAddress &bind_address={}, int family=AF_UNSPEC)
| Create a new connecter for the given address.
void | Kill ()
| Kill this connecter.

## Private Attributes
ClientNetworkStunSocketHandler * | stun_handler
std::string | token
uint8_t | family

## Additional Inherited Members
Static Public Member Functions inherited from TCPConnecter
static void | CheckCallbacks ()
| Check whether we need to call the callback, i.e.
static void | KillAll ()
| Kill all connection attempts.
template<class T , typename... Args>
static std::shared_ptr< TCPConnecter > | Create (Args &&... args)
| Create the connecter, and initiate connecting by putting it in the collection of TCP connections to make.

## Detailed Description

Connect to the STUN server.

Definition at line 19 of file network_stun.cpp.

## Constructor & Destructor Documentation

## ◆ NetworkStunConnecter()

NetworkStunConnecter::NetworkStunConnecter | ( | ClientNetworkStunSocketHandler * | stun_handler,
|  | std::string_view | connection_string,
|  | std::string_view | token,
|  | uint8_t | family
| ) |  |
| inline

Initiate the connecting.

Parameters

  stun_handler | The handler for this request.
  connection_string | The address of the server.

Definition at line 31 of file network_stun.cpp.

## Member Function Documentation

## ◆ OnConnect()

void NetworkStunConnecter::OnConnect | ( | SOCKET | s | ) |
| inlineoverridevirtual

Callback when the connection succeeded.

Parameters

  s | the socket that we opened

Reimplemented from TCPConnecter.

Definition at line 51 of file network_stun.cpp.

References ClientNetworkStunSocketHandler::connecter, Debug, NetworkAddress::GetSockAddress(), ClientNetworkStunSocketHandler::local_addr, and NetworkTCPSocketHandler::sock.

## ◆ OnFailure()

void NetworkStunConnecter::OnFailure | ( |  | ) |
| inlineoverridevirtual

Callback for when the connection attempt failed.

Reimplemented from TCPConnecter.

Definition at line 39 of file network_stun.cpp.

References _network_coordinator_client, ClientNetworkStunSocketHandler::connecter, Debug, and ClientNetworkCoordinatorSocketHandler::StunResult().

## Field Documentation

## ◆ family

uint8_t NetworkStunConnecter::family
| private

Definition at line 23 of file network_stun.cpp.

## ◆ stun_handler

ClientNetworkStunSocketHandler* NetworkStunConnecter::stun_handler
| private

Definition at line 21 of file network_stun.cpp.

## ◆ token

std::string NetworkStunConnecter::token
| private

Definition at line 22 of file network_stun.cpp.

The documentation for this class was generated from the following file:

- src/network/network_stun.cpp